/***
*limits.h - Ausfhrungsabhngige Werte
*
*	Copyright (c) 1985-1990, Microsoft Corporation.  Alle Rechte vorbehalten.
*
* Zweck:
*   Enthlt Definitionen fr mehrere ausfhrungsabhngige Werte,
*   die in C-Programmen oft verwendet werden.
*   [ANSI]
*
***/

#define CHAR_BIT	  8		/* Hchstwet der Bits in char */
#define SCHAR_MIN	(-127)		/* Mindestwert fr signed char */
#define SCHAR_MAX	  127		/* Hchstwert fr signed char */
#define UCHAR_MAX	  0xff		/* Hchstwert fr unsigned char */
#ifndef _CHAR_UNSIGNED
#define CHAR_MIN	SCHAR_MIN	/* Mindestwert fr char */
#define CHAR_MAX	SCHAR_MAX	/* Hchstwert fr char */
#else
#define CHAR_MIN	  0
#define CHAR_MAX	UCHAR_MAX
#endif
#define	MB_LEN_MAX	  1		/* Anzahl der Bytes in Multibyte char */
#define SHRT_MIN	(-32767)	/*  Mindestwert fr (signed) short */
#define SHRT_MAX	  32767 	/* Hchstwert fr (signed) short  */
#define USHRT_MAX	  0xffff	/* Hchstwert fr unsigned short */
#define INT_MIN 	(-32767)	/* Mindestwert fr (signed) int */
#define INT_MAX 	  32767 	/* Hchstwert fr (signed) int */
#define UINT_MAX	  0xffff	/* Hchstwert fr unsigned int */
#define LONG_MIN	(-2147483647)	/* Mindestwert fr (signed) long */
#define LONG_MAX	  2147483647	/* Hchstwert fr (signed) long */
#define ULONG_MAX	  0xffffffff	/* Hchstwert fr unsigned long */
