/***
*signal.h - definiert Signalwerte und -routinen
*
*	Copyright (c) 1985-1990, Microsoft Corporation.  Alle Rechte vorbehalten.
*
* Zweck:
*	Hier werden die Signalwerte definiert und die Signalfunktionen deklariert
*	[ANSI/System V]
*
****/

#if defined(_DLL) && !defined(_MT)
#error _DLL kann ohne _MT nicht definiert werden
#endif

#ifdef _MT
#define _FAR_ _far
#else
#define _FAR_
#endif

#ifdef	_DLL
#define _LOADDS_ _loadds
#else
#define _LOADDS_
#endif

#ifndef _SIG_ATOMIC_T_DEFINED
typedef int sig_atomic_t;
#define _SIG_ATOMIC_T_DEFINED
#endif


#define NSIG 23     /* Hchste Signalanzahl plus 1 */

/* Signaltypen */
/* SIGINT, SIGFPE, SIGILL, SIGSEGV und SIGABRT werden unter DOS 3.x anerkannt */

#define SIGINT		2	/* Unterbrechung - entspricht DOS 3.x int 23H */
#define SIGILL		4	/* unzulssiger Befehl - ungltiges Funktionsabbild */
#define SIGFPE		8	/* Gleitkommaausnahme */
#define SIGSEGV 	11	/* Segmentverletzung */
#define SIGTERM 	15	/* Software-Abbruchsignal von kill */
#define SIGUSR1 	16	/* Benutzerdefiniertes Signal 1 */
#define SIGUSR2 	17	/* Benutzerdefiniertes Signal 2 */
#define SIGUSR3 	20	/* Benutzerdefiniertes Signal 3 */
#define SIGBREAK	21	/* STRG-UNTBR */
#define SIGABRT 	22	/* Abnormale Beendigung durch Abbruchaufruf (abort) */


/* Signal-Aktionscodes */
/* SIG_DFL und SIG_IGN werden unter DOS 3.x anerkannt */

#define SIG_DFL (void (_FAR_ _cdecl _LOADDS_ *)())0	 /* vorgegebene Signalaktion */
#define SIG_IGN (void (_FAR_ _cdecl _LOADDS_ *)())1	 /* ignorieren */
#define SIG_SGE (void (_FAR_ _cdecl _LOADDS_ *)())3	 /* Signal erhlt Fehler */
#define SIG_ACK (void (_FAR_ _cdecl _LOADDS_ *)())4	 /* Fehler falls Handler
                                                           nicht eingerichtet ist */


/* Signal-Fehlerwert (vom signal-Aufruf bei Fehler produziert) */

#define SIG_ERR (void (_FAR_ _cdecl _LOADDS_ *)())-1	 /* signal-Fehlerwert */


/* Funktionsprototypen */

void (_FAR_ _cdecl _LOADDS_ * _FAR_ _cdecl signal(int,
	void (_FAR_ _cdecl _LOADDS_ *)()))();
#ifndef _MT
int _FAR_ _cdecl raise(int);
#endif
