/***
*stdlib.h -Deklarationen/Definitionen fr oft verwendete
*            Bibliotheksfunktionen
*
*	Copyright (c) 1985-1990, Microsoft Corporation.  Alle Rechte vorbehalten.
*
* Zweck:
*	Diese Datei enthlt die Funktionsdeklarationen fr oft verwendete
*	Bibliotheksfunktionen, die weder in andere .H-Dateien passen bzw.,
*	wie toupper/tolower aus anderen Grnden nicht an der normalen Stelle
*	deklariert werden knnen (im Falle von toupper/tolower wre es ctype.h).
*	[ANSI]
*
***/

#if defined(_DLL) && !defined(_MT)
#error _DLL kann ohne _MT nicht definiert werden
#endif

#ifdef _MT
#define _FAR_ _far
#else
#define _FAR_
#endif

#ifdef	_DLL
#define _LOADDS_ _loadds
#else
#define _LOADDS_
#endif

#ifndef _SIZE_T_DEFINED
typedef unsigned int size_t;
#define _SIZE_T_DEFINED
#endif

/* Definition des NUll-Zeiger Wertes */

#ifndef NULL
#if (_MSC_VER >= 600)
#define NULL	((void *)0)
#elif (defined(M_I86SM) || defined(M_I86MM))
#define NULL	0
#else
#define NULL	0L
#endif
#endif

/* Definition des Rckgabetyps fr die Funktion onexit() */

#define EXIT_SUCCESS	0
#define EXIT_FAILURE	1

#ifndef _ONEXIT_T_DEFINED
typedef int (_FAR_ _cdecl _LOADDS_ * _cdecl onexit_t)();
#define _ONEXIT_T_DEFINED
#endif


/* Datenstruktur-Definitionen fr Laufzeitroutinen div und ldiv */

#ifndef _DIV_T_DEFINED

typedef struct _div_t {
	int quot;
	int rem;
} div_t;

typedef struct _ldiv_t {
	long quot;
	long rem;
} ldiv_t;

#define _DIV_T_DEFINED
#endif

/* Hchstwert, der sich aus der Funktion rand (Zufallszahlen) ergeben kann */

#define RAND_MAX 0x7fff


/* Makros fr min und max */

#define max(a,b)	(((a) > (b)) ? (a) : (b))
#define min(a,b)	(((a) < (b)) ? (a) : (b))


/* Gren der Zwischenspeicher fr die Funktionen _makepath() und _splitpath().
 * Beachten Sie, da das abschlieende Nullzeichen mit bercksichtigt wird.
 */

#define _MAX_PATH	260	/* Hchstlnge fr vollst. Pfadnamen */
#define _MAX_DRIVE	3	/* Hchstlnge fr Laufwerksteil */
#define _MAX_DIR	256	/* Hchstlnge fr Pfadbezeichnung */
#define _MAX_FNAME	256	/* Hchstlnge fr Dateinamen */
#define _MAX_EXT	256	/* Hchstlnge fr Dateiname-Erweiterung */

/* externe Variablendeklarationen */

#ifdef	_MT
extern int _far * _cdecl _far volatile _errno(void);
extern unsigned _far * _cdecl _far __doserrno(void);
#define errno	    (*_errno())
#define _doserrno   (*__doserrno())
#else
extern int _near _cdecl volatile errno; 	/* XENIX-artige Fehlernumner */
extern int _near _cdecl _doserrno;		/* MS-DOS-Systemfehlerwert */
#endif
extern char * _near _cdecl sys_errlist[];	/* perror Fehlermeldungstabelle */
extern int _near _cdecl sys_nerr;		/* Anzahl der Eintragungen in    */
				            /* Tabelle sys_errlist           */

#ifdef _DLL
extern char ** _FAR_ _cdecl environ;		/* Zeiger zu Umgebungstabelle */
extern int _FAR_ _cdecl _fmode; 		/* Standard-Datei bersetzungsmodus */
extern int _FAR_ _cdecl _fileinfo;		/* ffne Dateiinformationsmodus (fr spawn) */
#else
extern char ** _near _cdecl environ;		/* Zeiger zu Umgebungstabelle */
extern int _near _cdecl _fmode; 		/* Standard-Datei bersetzungsmodus */
extern int _near _cdecl _fileinfo;		/* ffne Dateiinformationsmodus (fr spawn) */
#endif

extern unsigned int _near _cdecl _psp;		/* Programmsegment-Prfix */

/* OS Haupt/Unter-Versionsnummer */

extern unsigned char _near _cdecl _osmajor;
extern unsigned char _near _cdecl _osminor;

#define DOS_MODE	0	/* Real Modus (DOS) */
#define OS2_MODE	1	/* Protected Modus (OS/2) */

extern unsigned char _near _cdecl _osmode;


/* Funktionsprototypen */

#ifdef	_MT
double _FAR_ _pascal atof(const char _FAR_ *);
double _FAR_ _pascal strtod(const char _FAR_ *, char _FAR_ * _FAR_ *);
ldiv_t _FAR_ _pascal ldiv(long, long);
#else	/* not _MT */
double _FAR_ _cdecl atof(const char _FAR_ *);
double _FAR_ _cdecl strtod(const char _FAR_ *, char _FAR_ * _FAR_ *);
ldiv_t _FAR_ _cdecl ldiv(long, long);
#endif

void _FAR_ _cdecl abort(void);
int _FAR_ _cdecl abs(int);
int _FAR_ _cdecl atexit(void (_cdecl _FAR_ _LOADDS_ *)(void));
int _FAR_ _cdecl atoi(const char _FAR_ *);
long _FAR_ _cdecl atol(const char _FAR_ *);
long double _FAR_ _cdecl _atold(const char _FAR_ *);
void _FAR_ * _FAR_ _cdecl bsearch(const void _FAR_ *, const void _FAR_ *,
	size_t, size_t, int (_FAR_ _cdecl *)(const void _FAR_ *,
	const void _FAR_ *));
void _FAR_ * _FAR_ _cdecl calloc(size_t, size_t);
div_t _FAR_ _cdecl div(int, int);
char _FAR_ * _FAR_ _cdecl ecvt(double, int, int _FAR_ *, int _FAR_ *);
void _FAR_ _cdecl exit(int);
void _FAR_ _cdecl _exit(int);
char _FAR_ * _FAR_ _cdecl fcvt(double, int, int _FAR_ *, int _FAR_ *);
void _FAR_ _cdecl free(void _FAR_ *);
char _FAR_ * _FAR_ _cdecl _fullpath(char _FAR_ *, const char _FAR_ *,
	size_t);
char _FAR_ * _FAR_ _cdecl gcvt(double, int, char _FAR_ *);
char _FAR_ * _FAR_ _cdecl getenv(const char _FAR_ *);
char _FAR_ * _FAR_ _cdecl itoa(int, char _FAR_ *, int);
long _FAR_ _cdecl labs(long);
unsigned long _FAR_ _cdecl _lrotl(unsigned long, int);
unsigned long _FAR_ _cdecl _lrotr(unsigned long, int);
char _FAR_ * _FAR_ _cdecl ltoa(long, char _FAR_ *, int);
void _FAR_ _cdecl _makepath(char _FAR_ *, const char _FAR_ *,
	const char _FAR_ *, const char _FAR_ *, const char _FAR_ *);
void _FAR_ * _FAR_ _cdecl malloc(size_t);
onexit_t _FAR_ _cdecl onexit(onexit_t);
void _FAR_ _cdecl perror(const char _FAR_ *);
int _FAR_ _cdecl putenv(const char _FAR_ *);
void _FAR_ _cdecl qsort(void _FAR_ *, size_t, size_t, int (_FAR_ _cdecl *)
	(const void _FAR_ *, const void _FAR_ *));
unsigned int _FAR_ _cdecl _rotl(unsigned int, int);
unsigned int _FAR_ _cdecl _rotr(unsigned int, int);
int _FAR_ _cdecl rand(void);
void _FAR_ * _FAR_ _cdecl realloc(void _FAR_ *, size_t);
void _FAR_ _cdecl _searchenv(const char _FAR_ *, const char _FAR_ *,
	char _FAR_ *);
void _FAR_ _cdecl _splitpath(const char _FAR_ *, char _FAR_ *,
	char _FAR_ *, char _FAR_ *, char _FAR_ *);
void _FAR_ _cdecl srand(unsigned int);
long _FAR_ _cdecl strtol(const char _FAR_ *, char _FAR_ * _FAR_ *,
	int);
long double _FAR_ _cdecl _strtold(const char _FAR_ *,
	char _FAR_ * _FAR_ *);
unsigned long _FAR_ _cdecl strtoul(const char _FAR_ *,
	char _FAR_ * _FAR_ *, int);
void _FAR_ _cdecl swab(char _FAR_ *, char _FAR_ *, int);
int _FAR_ _cdecl system(const char _FAR_ *);
char _FAR_ * _FAR_ _cdecl ultoa(unsigned long, char _FAR_ *, int);

#ifndef tolower 	/* wurde tolower-Definition entfernt, Funktion benutzen */
int _FAR_ _cdecl tolower(int);
#endif	/* tolower */

#ifndef toupper 	/* wurde toupper-Definition entfernt, Funktion benutzen */
int _FAR_ _cdecl toupper(int);
#endif	/* toupper */
