/***
*sys\stat.h - definiert die von stat() und fstat() benutzten Strukturen
*
*	Copyright (c) 1985-1990, Microsoft Corporation.  Alle Rechte vorbehalten.
*
*Zweck:
*	Diese Datei definiert die von stat() und fstat() benutzten Strukturen.
*	[System V]
*
****/

#if defined(_DLL) && !defined(_MT)
#error _DLL kann ohne _MT nicht definiert werden
#endif

#ifdef _MT
#define _FAR_ _far
#else
#define _FAR_
#endif

#ifndef _TIME_T_DEFINED
typedef long time_t;
#define _TIME_T_DEFINED
#endif

/* Definition der Strukturen fr Statusinformations-Rckgabe */

#ifndef _STAT_DEFINED
struct stat {
	dev_t st_dev;
	ino_t st_ino;
	unsigned short st_mode;
	short st_nlink;
	short st_uid;
	short st_gid;
	dev_t st_rdev;
	off_t st_size;
	time_t st_atime;
	time_t st_mtime;
	time_t st_ctime;
	};
#define _STAT_DEFINED
#endif

#define S_IFMT		0170000 	/* Dateityp-Maske */
#define S_IFDIR 	0040000 	/* Verzeichnis */
#define S_IFCHR 	0020000 	/* Spezialzeichen */
#define S_IFREG 	0100000 	/* Normal */
#define S_IREAD 	0000400 	/* Leseerlaubnis, Eigentmer */
#define S_IWRITE	0000200 	/* Schreiberlaubnis, Eigentmer */
#define S_IEXEC 	0000100 	/* Ausfhrungs-/Sucherlaubnis, Eigentmer */


/* Funktionsprototypen */

int _FAR_ _cdecl fstat(int, struct stat _FAR_ *);
int _FAR_ _cdecl stat(char _FAR_ *, struct stat _FAR_ *);
