/***
*time.h - Definitionen/Deklarationen fr Uhrzeit-Routinen
*
*	Copyright (c) 1985-1990, Microsoft Corporation.  Alle Rechte vorbehalten.
*
* Zweck:
*	Diese Datei enthlt Deklarationen von Uhrzeit-Routinen und definiert
*	die von den Routinen localtime und gmtime produzierten und von asctime
*	verwerteten Strukturen.
*	[ANSI/System V]
*
***/

#if defined(_DLL) && !defined(_MT)
#error  _DLL kann ohne _MT nicht definiert werden
#endif

#ifdef _MT
#define _FAR_ _far
#else
#define _FAR_
#endif

/* Definition des ausfhrungsdefinierten Uhrzeit-Typs */

#ifndef _TIME_T_DEFINED
typedef long time_t;
#define _TIME_T_DEFINED
#endif

#ifndef _CLOCK_T_DEFINED
typedef long clock_t;
#define _CLOCK_T_DEFINED
#endif

#ifndef _SIZE_T_DEFINED
typedef unsigned int size_t;
#define _SIZE_T_DEFINED
#endif

/* Struktur zur Verwendung mit den Funktionen localtime(), gmtime(), etc. */

#ifndef _TM_DEFINED
struct tm {
	int tm_sec;	/* Sekunden nach der Minute - [0,59] */
	int tm_min;	/* Minuten nach der Stunde - [0,59] */
	int tm_hour;	/* Stunden seit Mitternacht - [0,23] */
	int tm_mday;	/* Monatstag - [1,31] */
	int tm_mon;	/* Monate seit Januar - [0,11] */
	int tm_year;	/* Jahre seit 1900 */
	int tm_wday;	/* Tage seit Sonntag - [0,6] */
	int tm_yday;	/* Tage seit dem 1.Januar - [0,365] */
	int tm_isdst;	/* Sommerzeitangabe */
	};
#define _TM_DEFINED
#endif


/* Definition Null-Zeiger Wert */

#ifndef NULL
#if (_MSC_VER >= 600)
#define NULL	((void *)0)
#elif (defined(M_I86SM) || defined(M_I86MM))
#define NULL	0
#else
#define NULL	0L
#endif
#endif


/* Makro fr Clock-Ticks- ANSI Version */

#define CLOCKS_PER_SEC	1000

/* clock ticks Makro - veraltete Version */

#define CLK_TCK 	1000


/* externe Deklarationen fr die von den ctime-Routinen benutzten 
 * Globalvariablen.
 */

#ifdef _DLL
extern int _FAR_ _cdecl daylight;     /* ungleich Null falls Sommerzeit verwendet wird */
extern long _FAR_ _cdecl timezone;    /* Unterschied in Sek zwischen */
						/* GMT und Ortszeit */
extern char _FAR_ * _FAR_ _cdecl tzname[2]; /* Zeitzonennamen fr */
					/* Standard-/Sommerzeit */
#else
extern int _near _cdecl daylight;     /* ungleich Null falls Sommerzeit verwendet wird */
extern long _near _cdecl timezone;    /* Unterschied in Sek zwischen */
						/* GMT und Ortszeit */
extern char * _near _cdecl tzname[2]; /* Zeitzonennamen fr */
					/* Standard-/Sommerzeit */
#endif


/* Funktionsprototypen */

#ifdef _MT
double _FAR_ _pascal difftime(time_t, time_t);
#else
double _FAR_ _cdecl difftime(time_t, time_t);
#endif

char _FAR_ * _FAR_ _cdecl asctime(const struct tm _FAR_ *);
char _FAR_ * _FAR_ _cdecl ctime(const time_t _FAR_ *);
clock_t _FAR_ _cdecl clock(void);
struct tm _FAR_ * _FAR_ _cdecl gmtime(const time_t _FAR_ *);
struct tm _FAR_ * _FAR_ _cdecl localtime(const time_t _FAR_ *);
time_t _FAR_ _cdecl mktime(struct tm _FAR_ *);
size_t _FAR_ _cdecl strftime(char _FAR_ *, size_t, const char _FAR_ *,
	const struct tm _FAR_ *);
char _FAR_ * _FAR_ _cdecl _strdate(char _FAR_ *);
char _FAR_ * _FAR_ _cdecl _strtime(char _FAR_ *);
time_t _FAR_ _cdecl time(time_t _FAR_ *);
void _FAR_ _cdecl tzset(void);
